#include <stdio.h>
#define MAX 25

char  nome[MAX];
char  cognome[MAX];
int   date[MAX];
int   vaux[MAX];
int   mese, esami;
float esito[12];
float media = 0.0;
int   finito = 0;

/* Questa funzione gestisce l'inserimento del nome del paziente */
void paziente();
/* Questa funzione gestisce il numero di mesi da monitorare */
void mesi();
/* Questa funzione gestisce il tipo di esame */
void tipoesame();
/* Questa funzione gestisce un vettore di date */
void data(int d[]);
/* Questa funzione calcola la media di un vettore di numeri */
float cmedia(float *v);

/* Questa funzione gestisce data ed esito esame */
void dataesito();

/* Questa funzione ordina i valori di un array in ordine decrescente */
void selectionSort(float *v);

/* Questa funzione stampa tutto */
void printall(char *a, char *d, int, int, int *dat, float *v, float);


int main()
{
	int i;

    paziente();
    mesi();
    tipoesame();
    dataesito();

    media = cmedia(esito);
    printall(nome, cognome, mese, esami, date, esito, media);

    scanf("%d",&i);
	return 0;
}


void paziente()
{
	printf("Inserisci il nome del paziente - massimo 25 caratteri ");
	scanf("%s", nome);
	printf("Inserisci il cognome del paziente - massimo 25 caratteri ");
	scanf("%s", cognome);
}


void mesi()
{
	printf("Inserisci il numero di mesi ");
	scanf("%d", &mese);
}

void tipoesame()
{
	printf("Scegli un tipo di esame: digita 1 per FT3, 2 per FT4, 3 per TSH ");
	scanf("%d", &esami);

}

void dataesito()
{
int i;
for(i=0;i<mese;i++){
       printf("Inserisci data (intero) ed esito (float)");
       scanf("%d %f",&date[i],&esito[i]);
    }
}


float cmedia(float *c){
	int j;
	float res;
	for(j=0; j < mese; j++){
	     res = res + c[j];
	}
    res = res / mese;
	return res;
}


void selectionSort(float *v)
{
	int i, j, jmin, aux;
	for (i=0; i<mese; i++) vaux[i]=i;

    for (i=0; i< mese-1; i++)
	{
		/* trova il pi� piccolo elemento da i a n-1 */
		jmin = i;
		for (j=i+1; j<mese; j++)
		{
			if (v[vaux[j]] > v[vaux[jmin]])
			{
				jmin = j;
			}
        }
		/* scambia gli elementi in posizione i e jmin */
		aux = vaux[jmin];
		vaux[jmin] = vaux[i];
		vaux[i] = aux;
	}
}


void printall(char *a, char *d, int b, int c, int *date, float *v, float m){

    int y,w;
	printf("Nome: %s %s\n",a, d);
	printf("\n Numero esami: %d", b);
	printf("\n Tipo analisi ( 1 FT3, 2 FT4, 3 TSH): %d", c);

    for(y = 0; y < b; y++){
	 printf("\n Esame: %d", y+1);
   printf("\n Data %d", date[y]);
	 printf("\n Valore: %.2f", v[y]);
    }

    printf("\n Riepilogo Monitoraggio: ");
    selectionSort(v);
    for(w=0; w < b; w++){
        printf("\n Data %d Valore %.2f",date[vaux[w]],v[vaux[w]]);
	}
	printf("\n Valore medio: %.2f", m);

}
