#include <stdio.h>

const int max_r = 20;
const int max_c = 20;

void stampaB(float A[max_r][max_c+1], int r, int c){
	int i,j;
	for (i=0; i<r; i++){
		for (j=0;j<c;j++){
			printf("%.2f ", A[i][j]);
		}
		printf("\n");
	}
}

int occorrenze(float A[max_r][max_c], int r, int c, float k){
	int count=0, i, j;
	for (i=0; i<r; i++){
		for(j=0; j<c; j++){
			if (k<A[i][j]) count++;
		}
	}

	return count;
}

void max(float A[max_r][max_c], int r, int c, float *M){
	int  i, j;
	*M = A[0][0];
	for (i=0; i<r; i++){
		for(j=1; j<c; j++){
			if (*M<A[i][j]) *M=A[i][j];
		}
	}
}

void inserisci(float A[max_r][max_c], int r, int c, float B[max_r][max_c+1]){
	int i,j;	
	for (i=0; i<r; i++){
		for (j=0; j<(c+1); j++){
			if (j==0){
				B[i][j] = 0;
			}
			else {
				B[i][j] = A[i][j-1];
			}
		}
	}
}

int main(){

	
	float DATI[max_r][max_c];
	int rig, col;	
	FILE *fdat;
	if ((fdat= fopen("dati.txt", "r")) == NULL) {printf("errore di apertura"); return 0;}
	
	fscanf(fdat, "%d %d", &rig, &col);
	printf("%d %d\n", rig, col);

	if (rig>20 || col >20){
		printf("Matrice troppo grande. Dimensione massima 20x20. Modificare il file \"Dati.txt\" e riprovare.\n");
		return 0;
	}

	int i, j;

	for (i=0; i<rig; i++){
		for (j=0;j<col;j++){
			fscanf(fdat,"%f", &DATI[i][j]);
		}
	}

	for (i=0; i<col; i++){
		for (j=0;j<rig;j++){
			printf("%.2f ", DATI[j][i]);
		}
		printf("\n");
	}

	float V;
	printf("valore da confrontare con DATI? ");
	scanf("%f", &V);
	printf("Numero di occorrenze: %d\n", occorrenze(DATI, rig, col, V));
	float M;
	max(DATI, rig, col, &M);
	printf("Valore massimo: %.2f\n", M);

	float B[max_r][max_c+1];
	inserisci(DATI, rig, col, B);
	stampaB(B, rig, col+1);
	
    system("PAUSE");
	return 0;
}
