#include <stdio.h>

/* Questa funzione legge due interi da standard input nelle due variabili passate */
void leggi(int* a, int* b);

/* Questa funzione stampa i due interi passati */
void stampa(int a, int b);

/* Questa funzione scambia i due interi nelle due variabili passate */
void scambia(int* a, int* b);

/* Questa funzione stampa i due interi passati e il massimo fra loro*/
void stampaMax(int a, int b);

int main()
{
	int a,b;
	leggi(&a,&b);
	stampa(a,b);
	scambia(&a,&b);
	stampaMax(a,b);
	return 0;
}

/* Questa funzione legge due interi da standard input nelle due variabili passate */
void leggi(int* a, int* b)
{
	printf("Inserire due interi separati da uno spazio: "); 
	scanf("%d %d", a,b);
	printf("\n");
}


/* Questa funzione stampa i due interi passati */
void stampa(int a, int b)
{
	printf("A: %d, B: %d\n",a,b);
}

/* Questa funzione scambia i due interi nelle due variabili passate */
void scambia(int* a, int* b)
{
	int temp=*a;
	*a=*b;
	*b=temp;	
}

/* Questa funzione stampa i due interi passati e il massimo fra loro*/
void stampaMax(int a, int b)
{
	if (a>b)
		printf("A: %d, B: %d, Max: %d\n",a,b,a);
	else
		printf("A: %d, B: %d, Max: %d\n",a,b,b);
}