#include <stdio.h>
#define MAX 10

// Elezioni con ballottaggio alla francese: 
// si vince con magg. assoluta se non c' maggioranza 
// si va al ballottaggio con >=12.5% dei voti 
//
// Scrivere un programma che prende in input il numero N di candidati
// (per semplicit indicati con in numero d'ordine 1...N) 
// Poi prende in input le schede dei votanti (un numero tra 1...N) 
// una alla volta; il valore -1 termina la votazione
// Infine effettua lo spoglio delle schede verificando se esiste un 
// candidato con maggioranza assoluta ed in caso negativo se ci sono
// candidati che vanno al ballottaggio (cio hanno raggiunto il 12.5% dei voti)
// Il programma deve stampare il vincitore o la lista dei candidati che vanno
// al ballottaggio

int quanti,nvoti;
int voti[MAX];

void leggi_numero_candidati(int*);

void leggi_schede(int,int*,int*);

void spoglio_schede(int,int*,int);

void ordina(int,int*);

void stampa_risultati(int,int*);




int main()
{  
 leggi_numero_candidati(&quanti);

 leggi_schede(quanti,voti,&nvoti);

 spoglio_schede(quanti,voti,nvoti);
 
 system("PAUSE");
 return 0;
}


//void leggi_numero_candidati

//void stampa_voti

//void leggi_schede

//void leggi_schede


void leggi_numero_candidati(int* quanti){
  do{
    printf("Inserisci numero di candidati ->");
    scanf("%d",quanti);
  }
  while (*quanti<=0 || *quanti>MAX);
  printf("Il numero dei candidati e': %d ",*quanti);    
}




void stampa_voti(int N,int* v){
  int i;
  for (i=0; i<N; printf("\n%d --> %d",i,v[i]),i++);   
}

void leggi_schede(int N,int* v,int* c){
  int voto=0;
  int count=0;
  printf("\nInizio delle votazioni\n\n");

  while(1){
    printf("Scegli in [0-%d],  -1 per terminare: ->",N-1);
    scanf("%d",&voto);
    if (voto>=0 && voto<N){    
     count++;  
     v[voto]++;
    }
    else if (voto==-1 && count>0) break;
         else printf("Input errato! Riprova...\n");
  }
//  stampa_voti(N,v);
  *c=count; 
}


void spoglio_schede(int N,int* v,int nvoti){
  int vinc[MAX];
  int i,vincitore,j=0;
  float max,bal;
  
  max=nvoti/2.0;
  bal=(nvoti*12.5)/100.0;
  printf("\nTotale Voti: %d\nMaggioranza: %f\nBallottaggio: %f\n",nvoti,max,bal);
  j=0;

  for (i=0; i<N;i++){
    if (v[i]>max) {
       printf("\nIl vincitore e': %d",i);
       return;
    }
    if (v[i]>=bal) vinc[j++]=i;
  }

  if (j>1){
   printf("\nVanno al ballottaggio: ");
   for (i=0; i<j;i++) printf("%d ",vinc[i]);
  }
  else printf("Tutto da rifare!\n");
}




